cmiranda_studiogenesis/routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();



Route::group(['middleware' => ['auth']], function() {

    Route::get('/home', 'HomeController@index')->name('home');

    Route::get('tarifas/{id}/create', 'TarifasController@create')->name('tarifas.agregar');

    Route::resource('usuarios', 'UsuariosController');
    Route::resource('categorias', 'CategoriasController');
    Route::resource('productos', 'ProductosController');

    Route::resource('tarifas', 'TarifasController');

});

cmiranda_studiogenesis/app/Http/Controllers/UsuariosController.php
<?php

namespace App\Http\Controllers;

use Response, File, Auth;
use Illuminate\Http\Request;
use App\User;

class UsuariosController extends Controller
{

    //Función index - Recogemos todos los Usuarios y los enviamos a la vista 'usuarios.index'.
    public function index(){
        $usuarios = User::paginate(10);
        return view('usuarios.index')->with('usuarios', $usuarios);
    }

    //Función create - Devolvemos la vista 'usuarios.create'.
    public function create() {
        return view('usuarios.create');
    }

    //Función store - Recogemos todos los datos vía Request, los validamos y se crea un nuevo Usuario.
    public function store(Request $request) {
        $usuario = new User;

        //Si recibimos una imagen.
        if($request->imagen){
            //Creamos un nombre con la fecha y la extensión de la imagen original.
            $imageName = time() . '.' . $request->imagen->getClientOriginalExtension();
            $request->imagen->move(public_path('imagenes/perfil'), $imageName);
        }else{
            //Si no recibimos nada se pondrá una imagen por defecto.
            $imageName = "user.jpg";
        }

        $usuario->name = $request->nombre;
        $usuario->last_name = $request->apellido;
        $usuario->email = $request->email;
        $usuario->birth_date = $request->fecha_nacimiento;
        $usuario->photo = $imageName;
        $usuario->password = bcrypt($request->password);

        $usuario->save();

        //Una vez creado nos redirigimos a la vista 'usuarios.index' con un mensaje de confirmación.
        return redirect()->route('usuarios.index')->with('success', 'Se ha añadido el usuario correctamente');
    }

    //Función edit - Encontramos el usuario seleccionado por la ID y los enviamos a lo vista 'usuarios.edit'.
    public function edit($id) {
        $usuario = User::find($id);

        return view('usuarios.edit')->with('usuario', $usuario);
    }

    //Función update - Recogemos todos los datos del usuario, la ID del usuario a modificar y guardamos los cambios.
    public function update(Request $request, $id) {

        $usuario = User::find($id);

        //Si recibimos una nueva imagen.
        if($request->imagen){
            //Se elimina la foto que tiene el usuario actual.
            File::delete('imagenes/perfil/'.$usuario->photo);

            //Creamos una nueva imagen y la movemos hasta el directorio 'imagenes/productos'
            $imagenNueva = time().'.'.request()->imagen->getClientOriginalExtension();
            $request->imagen->move(public_path('imagenes/perfil'), $imagenNueva);

        }else{
            //Si no mantenemos el mismo nombre
            $imagenNueva = $usuario->photo;
        }

        $usuario->name = $request->nombre;
        $usuario->last_name = $request->apellido;
        $usuario->email = $request->email;
        $usuario->birth_date = $request->fecha_nacimiento;
        $usuario->photo = $imagenNueva;

        $usuario->save();

        //Una vez modificado nos redirigimos a la vista 'productos.index' con un mensaje de confirmación.
        return redirect()->route('usuarios.index')->with('success', 'Se ha modificado el usuario correctamente');
    }

    //Función destroy - Encontramos el usuario seleccionada y si existe se elimina.
    public function destroy($id) {
        $usuario = User::find($id);

        //Si intentamos eliminar el usuario logeado, nos enviara a 'usuarios.index' con un mensaje de error.
        if($usuario->id == Auth::id()){
            return redirect()->route('usuarios.index')->with('warning','No puedes eliminar al usuario logeado.');
        }else{
            $usuario->delete();
            //También eliminamos la imagen del usuario eliminado.
            File::delete('imagenes/perfil/'.$usuario->photo);
        }

        //Una vez modificado nos redirigimos a la vista 'usuarios.index' con un mensaje de confirmación.
        return redirect()->route('usuarios.index')->with('success','Se ha eliminado correctamente.');
    }





}

cmiranda_studiogenesis/resources/views/usuarios/create.blade.php
@extends('layouts.app')

@section('content')

    <div class="card">
        <div class="card-header">Añadir Usuario</div>
        <div class="card-body">

            @if ($errors->any())
                <div class="alert alert-danger">
                    <ul>
                        @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div>
            @endif

            <form method="POST" action="{{route('usuarios.store')}}" enctype="multipart/form-data">
                @csrf

                <div class="form-group">
                    <label for="nombre">Nombre:</label>
                    <input type="text" class="form-control" name="nombre" id="nombre" required>
                </div>

                <div class="form-group">
                    <label for="nombre">Apellido:</label>
                    <input type="text" class="form-control" name="apellido" id="apellido" required>
                </div>

                <div class="form-group">
                    <label for="email">Correo Electrónico:</label>
                    <input type="text" class="form-control" name="email" id="email" required>
                </div>

                <div class="form-group">
                    <label for="fecha_nacimiento">Fecha de Nacimiento:</label>
                    <input type="date" class="form-control" name="fecha_nacimiento" id="fecha_nacimiento" max="{{date('Y-m-d')}}" required>
                </div>

                <div class="form-group">
                    <label for="password">Contraseña:</label>
                    <input type="password" class="form-control" name="password" id="password" required>
                </div>

                <div class="form-group">
                    <label>Imagen de Perfil</label>
                    <input type="file" class="form-control-file" id="imagen" name="imagen">
                    <br>
                </div>

                <a href="{{route('usuarios.index')}}" class="btn btn-danger">Atrás</a>
                <button type="submit" class="btn btn-primary">Añadir</button>
            </form>
        </div>
    </div>

@endsection

cmiranda_studiogenesis/resources/views/usuarios/edit.blade.php
@extends('layouts.app')

@section('content')

    <div class="card">
        <div class="card-header">Actualizar Usuario</div>
        <div class="card-body">

            @if ($errors->any())
                <div class="alert alert-danger">
                    <ul>
                        @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div>
            @endif

            <div class="row">
                <div class="col">
                    @if(strpos($usuario->photo,'https') !== false)
                        <img src="{{$usuario->photo}}" style="width:150px; height:150px; float:left; border-radius:50%; margin-right:25px; margin-bottom: 25px;">
                    @else
                        <img src="{{asset('imagenes/perfil/'.$usuario->photo)}}" style="width:150px; height:150px; float:left; border-radius:50%; margin-right:25px; margin-bottom: 25px;">
                    @endif
                    <h2>{{ $usuario->name ." ". $usuario->last_name }}</h2>
                    <hr>
                </div>
            </div>

            <div class="row">
                <div class="col">
                    <form method="POST" action="{{route('usuarios.update', $usuario->id)}}" enctype="multipart/form-data">
                        @csrf @method('PATCH')

                        <div class="form-group">
                            <label for="nombre">Nombre</label>
                            <input type="text" class="form-control" name="nombre" value="{{$usuario->name}}" required>
                        </div>

                        <div class="form-group">
                            <label for="nombre">Apellido</label>
                            <input type="text" class="form-control" name="apellido" id="nombre" value="{{$usuario->last_name}}" required>
                        </div>

                        <div class="form-group">
                            <label for="email">Correo Electrónico</label>
                            <input type="text" class="form-control" name="email" id="email" value="{{$usuario->email}}" required>
                        </div>

                        <div class="form-group">
                            <label for="fecha_nacimiento">Fecha de Nacimiento:</label>
                            <input type="date" class="form-control" name="fecha_nacimiento" id="fecha_nacimiento" max="{{date('Y-m-d')}}" value="{{$usuario->birth_date}}" required>
                        </div>

                        <div class="form-group">
                            <label>Imagen de Perfil</label>
                            <input type="file" class="form-control-file" id="imagen" name="imagen">
                            <br>
                        </div>

                        <a href="{{route('usuarios.index')}}" class="btn btn-danger">Atrás</a>
                        <button type="submit" class="btn btn-primary">Actualizar Usuario</button>
                    </form>
                </div>
            </div>
        </div>
    </div>

@endsection

cmiranda_studiogenesis/resources/views/usuarios/index.blade.php
@extends('layouts.app')

@section('content')

    <div class="container">
        <div class="float-right">
            <a href="{{route('usuarios.create')}}" class="btn btn-primary">Añadir Usuario</a>
        </div>
        <h1 style="font-size: 2.2rem">Lista de Usuarios</h1>

            @if(session()->get('success'))
                <div class="alert alert-success">
                    {{ session()->get('success') }}
                </div>
                <br>
            @elseif(session()->get('warning'))
                <div class="alert alert-warning">
                    {{ session()->get('warning') }}
                </div>
                <br>
            @endif

        <div class="row justify-content-center">
            <div class="col">
                <table class="table">
                    <thead>
                    <tr>
                        <th scope="col">#ID</th>
                        <th scope="col">Nombre</th>
                        <th scope="col">Apellido</th>
                        <th scope="col">Fecha Nacimiento</th>
                        <th scope="col">Correo Electrónico</th>
                        <th scope="col">Acción</th>
                    </tr>
                    </thead>
                    <tbody>
                    @foreach($usuarios as $user)
                        <tr>
                            <th>{{$user->id}}</th>
                            <th>{{$user->name}}</th>
                            <th>{{$user->last_name}}</th>
                            <th>{{$user->birth_date}}</th>
                            <th>{{$user->email}}</th>
                            <th>
                                <a href="{{route('usuarios.edit',$user->id)}}" class="float-left">
                                    <button type="button" class="btn-primary btn-sm"><i class="far fa-edit"></i></button>
                                </a>

                                <form action="{{ route('usuarios.destroy', $user->id)}}" method="POST" class="float-left">
                                    @csrf @method('DELETE')
                                    <button type="submit" class="btn-danger btn-sm" onclick="return confirm('Estas seguro que quieres eliminar este usuario?')"><i class="far fa-trash-alt"></i></button>
                                </form>
                            </th>
                        </tr>
                    @endforeach
                    </tbody>
                </table>
            </div>
        </div>
        {{$usuarios->links()}}
    </div>

@endsection